// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package fakes

import (
	"context"
	"sync"
	"time"

	"github.com/rancher/norman/controller"
	"github.com/rancher/norman/objectclient"
	v3 "github.com/rancher/rancher/pkg/apis/management.cattle.io/v3"
	v31 "github.com/rancher/rancher/pkg/generated/norman/management.cattle.io/v3"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/apimachinery/pkg/watch"
	"k8s.io/client-go/tools/cache"
)

var (
	lockProjectNetworkPolicyListerMockGet  sync.RWMutex
	lockProjectNetworkPolicyListerMockList sync.RWMutex
)

// Ensure, that ProjectNetworkPolicyListerMock does implement v31.ProjectNetworkPolicyLister.
// If this is not the case, regenerate this file with moq.
var _ v31.ProjectNetworkPolicyLister = &ProjectNetworkPolicyListerMock{}

// ProjectNetworkPolicyListerMock is a mock implementation of v31.ProjectNetworkPolicyLister.
//
//     func TestSomethingThatUsesProjectNetworkPolicyLister(t *testing.T) {
//
//         // make and configure a mocked v31.ProjectNetworkPolicyLister
//         mockedProjectNetworkPolicyLister := &ProjectNetworkPolicyListerMock{
//             GetFunc: func(namespace string, name string) (*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the Get method")
//             },
//             ListFunc: func(namespace string, selector labels.Selector) ([]*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the List method")
//             },
//         }
//
//         // use mockedProjectNetworkPolicyLister in code that requires v31.ProjectNetworkPolicyLister
//         // and then make assertions.
//
//     }
type ProjectNetworkPolicyListerMock struct {
	// GetFunc mocks the Get method.
	GetFunc func(namespace string, name string) (*v3.ProjectNetworkPolicy, error)

	// ListFunc mocks the List method.
	ListFunc func(namespace string, selector labels.Selector) ([]*v3.ProjectNetworkPolicy, error)

	// calls tracks calls to the methods.
	calls struct {
		// Get holds details about calls to the Get method.
		Get []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Selector is the selector argument value.
			Selector labels.Selector
		}
	}
}

// Get calls GetFunc.
func (mock *ProjectNetworkPolicyListerMock) Get(namespace string, name string) (*v3.ProjectNetworkPolicy, error) {
	if mock.GetFunc == nil {
		panic("ProjectNetworkPolicyListerMock.GetFunc: method is nil but ProjectNetworkPolicyLister.Get was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockProjectNetworkPolicyListerMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockProjectNetworkPolicyListerMockGet.Unlock()
	return mock.GetFunc(namespace, name)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedProjectNetworkPolicyLister.GetCalls())
func (mock *ProjectNetworkPolicyListerMock) GetCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockProjectNetworkPolicyListerMockGet.RLock()
	calls = mock.calls.Get
	lockProjectNetworkPolicyListerMockGet.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *ProjectNetworkPolicyListerMock) List(namespace string, selector labels.Selector) ([]*v3.ProjectNetworkPolicy, error) {
	if mock.ListFunc == nil {
		panic("ProjectNetworkPolicyListerMock.ListFunc: method is nil but ProjectNetworkPolicyLister.List was just called")
	}
	callInfo := struct {
		Namespace string
		Selector  labels.Selector
	}{
		Namespace: namespace,
		Selector:  selector,
	}
	lockProjectNetworkPolicyListerMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockProjectNetworkPolicyListerMockList.Unlock()
	return mock.ListFunc(namespace, selector)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedProjectNetworkPolicyLister.ListCalls())
func (mock *ProjectNetworkPolicyListerMock) ListCalls() []struct {
	Namespace string
	Selector  labels.Selector
} {
	var calls []struct {
		Namespace string
		Selector  labels.Selector
	}
	lockProjectNetworkPolicyListerMockList.RLock()
	calls = mock.calls.List
	lockProjectNetworkPolicyListerMockList.RUnlock()
	return calls
}

var (
	lockProjectNetworkPolicyControllerMockAddClusterScopedFeatureHandler sync.RWMutex
	lockProjectNetworkPolicyControllerMockAddClusterScopedHandler        sync.RWMutex
	lockProjectNetworkPolicyControllerMockAddFeatureHandler              sync.RWMutex
	lockProjectNetworkPolicyControllerMockAddHandler                     sync.RWMutex
	lockProjectNetworkPolicyControllerMockEnqueue                        sync.RWMutex
	lockProjectNetworkPolicyControllerMockEnqueueAfter                   sync.RWMutex
	lockProjectNetworkPolicyControllerMockGeneric                        sync.RWMutex
	lockProjectNetworkPolicyControllerMockInformer                       sync.RWMutex
	lockProjectNetworkPolicyControllerMockLister                         sync.RWMutex
)

// Ensure, that ProjectNetworkPolicyControllerMock does implement v31.ProjectNetworkPolicyController.
// If this is not the case, regenerate this file with moq.
var _ v31.ProjectNetworkPolicyController = &ProjectNetworkPolicyControllerMock{}

// ProjectNetworkPolicyControllerMock is a mock implementation of v31.ProjectNetworkPolicyController.
//
//     func TestSomethingThatUsesProjectNetworkPolicyController(t *testing.T) {
//
//         // make and configure a mocked v31.ProjectNetworkPolicyController
//         mockedProjectNetworkPolicyController := &ProjectNetworkPolicyControllerMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, handler v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             EnqueueFunc: func(namespace string, name string)  {
// 	               panic("mock out the Enqueue method")
//             },
//             EnqueueAfterFunc: func(namespace string, name string, after time.Duration)  {
// 	               panic("mock out the EnqueueAfter method")
//             },
//             GenericFunc: func() controller.GenericController {
// 	               panic("mock out the Generic method")
//             },
//             InformerFunc: func() cache.SharedIndexInformer {
// 	               panic("mock out the Informer method")
//             },
//             ListerFunc: func() v31.ProjectNetworkPolicyLister {
// 	               panic("mock out the Lister method")
//             },
//         }
//
//         // use mockedProjectNetworkPolicyController in code that requires v31.ProjectNetworkPolicyController
//         // and then make assertions.
//
//     }
type ProjectNetworkPolicyControllerMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, handler v31.ProjectNetworkPolicyHandlerFunc)

	// EnqueueFunc mocks the Enqueue method.
	EnqueueFunc func(namespace string, name string)

	// EnqueueAfterFunc mocks the EnqueueAfter method.
	EnqueueAfterFunc func(namespace string, name string, after time.Duration)

	// GenericFunc mocks the Generic method.
	GenericFunc func() controller.GenericController

	// InformerFunc mocks the Informer method.
	InformerFunc func() cache.SharedIndexInformer

	// ListerFunc mocks the Lister method.
	ListerFunc func() v31.ProjectNetworkPolicyLister

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Handler is the handler argument value.
			Handler v31.ProjectNetworkPolicyHandlerFunc
		}
		// Enqueue holds details about calls to the Enqueue method.
		Enqueue []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// EnqueueAfter holds details about calls to the EnqueueAfter method.
		EnqueueAfter []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// After is the after argument value.
			After time.Duration
		}
		// Generic holds details about calls to the Generic method.
		Generic []struct {
		}
		// Informer holds details about calls to the Informer method.
		Informer []struct {
		}
		// Lister holds details about calls to the Lister method.
		Lister []struct {
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *ProjectNetworkPolicyControllerMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.AddClusterScopedFeatureHandlerFunc: method is nil but ProjectNetworkPolicyController.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockProjectNetworkPolicyControllerMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockProjectNetworkPolicyControllerMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, handler)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.AddClusterScopedFeatureHandlerCalls())
func (mock *ProjectNetworkPolicyControllerMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Handler     v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyControllerMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockProjectNetworkPolicyControllerMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *ProjectNetworkPolicyControllerMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, handler v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.AddClusterScopedHandlerFunc: method is nil but ProjectNetworkPolicyController.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockProjectNetworkPolicyControllerMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockProjectNetworkPolicyControllerMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, handler)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.AddClusterScopedHandlerCalls())
func (mock *ProjectNetworkPolicyControllerMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Handler     v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyControllerMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockProjectNetworkPolicyControllerMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *ProjectNetworkPolicyControllerMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.AddFeatureHandlerFunc: method is nil but ProjectNetworkPolicyController.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    syncMoqParam,
	}
	lockProjectNetworkPolicyControllerMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockProjectNetworkPolicyControllerMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, syncMoqParam)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.AddFeatureHandlerCalls())
func (mock *ProjectNetworkPolicyControllerMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyControllerMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockProjectNetworkPolicyControllerMockAddFeatureHandler.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *ProjectNetworkPolicyControllerMock) AddHandler(ctx context.Context, name string, handler v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.AddHandlerFunc: method is nil but ProjectNetworkPolicyController.AddHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Name    string
		Handler v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:     ctx,
		Name:    name,
		Handler: handler,
	}
	lockProjectNetworkPolicyControllerMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockProjectNetworkPolicyControllerMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, handler)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.AddHandlerCalls())
func (mock *ProjectNetworkPolicyControllerMock) AddHandlerCalls() []struct {
	Ctx     context.Context
	Name    string
	Handler v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Name    string
		Handler v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyControllerMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockProjectNetworkPolicyControllerMockAddHandler.RUnlock()
	return calls
}

// Enqueue calls EnqueueFunc.
func (mock *ProjectNetworkPolicyControllerMock) Enqueue(namespace string, name string) {
	if mock.EnqueueFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.EnqueueFunc: method is nil but ProjectNetworkPolicyController.Enqueue was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockProjectNetworkPolicyControllerMockEnqueue.Lock()
	mock.calls.Enqueue = append(mock.calls.Enqueue, callInfo)
	lockProjectNetworkPolicyControllerMockEnqueue.Unlock()
	mock.EnqueueFunc(namespace, name)
}

// EnqueueCalls gets all the calls that were made to Enqueue.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.EnqueueCalls())
func (mock *ProjectNetworkPolicyControllerMock) EnqueueCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockProjectNetworkPolicyControllerMockEnqueue.RLock()
	calls = mock.calls.Enqueue
	lockProjectNetworkPolicyControllerMockEnqueue.RUnlock()
	return calls
}

// EnqueueAfter calls EnqueueAfterFunc.
func (mock *ProjectNetworkPolicyControllerMock) EnqueueAfter(namespace string, name string, after time.Duration) {
	if mock.EnqueueAfterFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.EnqueueAfterFunc: method is nil but ProjectNetworkPolicyController.EnqueueAfter was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		After     time.Duration
	}{
		Namespace: namespace,
		Name:      name,
		After:     after,
	}
	lockProjectNetworkPolicyControllerMockEnqueueAfter.Lock()
	mock.calls.EnqueueAfter = append(mock.calls.EnqueueAfter, callInfo)
	lockProjectNetworkPolicyControllerMockEnqueueAfter.Unlock()
	mock.EnqueueAfterFunc(namespace, name, after)
}

// EnqueueAfterCalls gets all the calls that were made to EnqueueAfter.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.EnqueueAfterCalls())
func (mock *ProjectNetworkPolicyControllerMock) EnqueueAfterCalls() []struct {
	Namespace string
	Name      string
	After     time.Duration
} {
	var calls []struct {
		Namespace string
		Name      string
		After     time.Duration
	}
	lockProjectNetworkPolicyControllerMockEnqueueAfter.RLock()
	calls = mock.calls.EnqueueAfter
	lockProjectNetworkPolicyControllerMockEnqueueAfter.RUnlock()
	return calls
}

// Generic calls GenericFunc.
func (mock *ProjectNetworkPolicyControllerMock) Generic() controller.GenericController {
	if mock.GenericFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.GenericFunc: method is nil but ProjectNetworkPolicyController.Generic was just called")
	}
	callInfo := struct {
	}{}
	lockProjectNetworkPolicyControllerMockGeneric.Lock()
	mock.calls.Generic = append(mock.calls.Generic, callInfo)
	lockProjectNetworkPolicyControllerMockGeneric.Unlock()
	return mock.GenericFunc()
}

// GenericCalls gets all the calls that were made to Generic.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.GenericCalls())
func (mock *ProjectNetworkPolicyControllerMock) GenericCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectNetworkPolicyControllerMockGeneric.RLock()
	calls = mock.calls.Generic
	lockProjectNetworkPolicyControllerMockGeneric.RUnlock()
	return calls
}

// Informer calls InformerFunc.
func (mock *ProjectNetworkPolicyControllerMock) Informer() cache.SharedIndexInformer {
	if mock.InformerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.InformerFunc: method is nil but ProjectNetworkPolicyController.Informer was just called")
	}
	callInfo := struct {
	}{}
	lockProjectNetworkPolicyControllerMockInformer.Lock()
	mock.calls.Informer = append(mock.calls.Informer, callInfo)
	lockProjectNetworkPolicyControllerMockInformer.Unlock()
	return mock.InformerFunc()
}

// InformerCalls gets all the calls that were made to Informer.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.InformerCalls())
func (mock *ProjectNetworkPolicyControllerMock) InformerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectNetworkPolicyControllerMockInformer.RLock()
	calls = mock.calls.Informer
	lockProjectNetworkPolicyControllerMockInformer.RUnlock()
	return calls
}

// Lister calls ListerFunc.
func (mock *ProjectNetworkPolicyControllerMock) Lister() v31.ProjectNetworkPolicyLister {
	if mock.ListerFunc == nil {
		panic("ProjectNetworkPolicyControllerMock.ListerFunc: method is nil but ProjectNetworkPolicyController.Lister was just called")
	}
	callInfo := struct {
	}{}
	lockProjectNetworkPolicyControllerMockLister.Lock()
	mock.calls.Lister = append(mock.calls.Lister, callInfo)
	lockProjectNetworkPolicyControllerMockLister.Unlock()
	return mock.ListerFunc()
}

// ListerCalls gets all the calls that were made to Lister.
// Check the length with:
//     len(mockedProjectNetworkPolicyController.ListerCalls())
func (mock *ProjectNetworkPolicyControllerMock) ListerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectNetworkPolicyControllerMockLister.RLock()
	calls = mock.calls.Lister
	lockProjectNetworkPolicyControllerMockLister.RUnlock()
	return calls
}

var (
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureHandler   sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureLifecycle sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedHandler          sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedLifecycle        sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddFeatureHandler                sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddFeatureLifecycle              sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddHandler                       sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockAddLifecycle                     sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockController                       sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockCreate                           sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockDelete                           sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockDeleteCollection                 sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockDeleteNamespaced                 sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockGet                              sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockGetNamespaced                    sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockList                             sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockListNamespaced                   sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockObjectClient                     sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockUpdate                           sync.RWMutex
	lockProjectNetworkPolicyInterfaceMockWatch                            sync.RWMutex
)

// Ensure, that ProjectNetworkPolicyInterfaceMock does implement v31.ProjectNetworkPolicyInterface.
// If this is not the case, regenerate this file with moq.
var _ v31.ProjectNetworkPolicyInterface = &ProjectNetworkPolicyInterfaceMock{}

// ProjectNetworkPolicyInterfaceMock is a mock implementation of v31.ProjectNetworkPolicyInterface.
//
//     func TestSomethingThatUsesProjectNetworkPolicyInterface(t *testing.T) {
//
//         // make and configure a mocked v31.ProjectNetworkPolicyInterface
//         mockedProjectNetworkPolicyInterface := &ProjectNetworkPolicyInterfaceMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle)  {
// 	               panic("mock out the AddClusterScopedFeatureLifecycle method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddClusterScopedLifecycleFunc: func(ctx context.Context, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle)  {
// 	               panic("mock out the AddClusterScopedLifecycle method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, lifecycle v31.ProjectNetworkPolicyLifecycle)  {
// 	               panic("mock out the AddFeatureLifecycle method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             AddLifecycleFunc: func(ctx context.Context, name string, lifecycle v31.ProjectNetworkPolicyLifecycle)  {
// 	               panic("mock out the AddLifecycle method")
//             },
//             ControllerFunc: func() v31.ProjectNetworkPolicyController {
// 	               panic("mock out the Controller method")
//             },
//             CreateFunc: func(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(name string, options *metav1.DeleteOptions) error {
// 	               panic("mock out the Delete method")
//             },
//             DeleteCollectionFunc: func(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error {
// 	               panic("mock out the DeleteCollection method")
//             },
//             DeleteNamespacedFunc: func(namespace string, name string, options *metav1.DeleteOptions) error {
// 	               panic("mock out the DeleteNamespaced method")
//             },
//             GetFunc: func(name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the Get method")
//             },
//             GetNamespacedFunc: func(namespace string, name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the GetNamespaced method")
//             },
//             ListFunc: func(opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error) {
// 	               panic("mock out the List method")
//             },
//             ListNamespacedFunc: func(namespace string, opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error) {
// 	               panic("mock out the ListNamespaced method")
//             },
//             ObjectClientFunc: func() *objectclient.ObjectClient {
// 	               panic("mock out the ObjectClient method")
//             },
//             UpdateFunc: func(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error) {
// 	               panic("mock out the Update method")
//             },
//             WatchFunc: func(opts metav1.ListOptions) (watch.Interface, error) {
// 	               panic("mock out the Watch method")
//             },
//         }
//
//         // use mockedProjectNetworkPolicyInterface in code that requires v31.ProjectNetworkPolicyInterface
//         // and then make assertions.
//
//     }
type ProjectNetworkPolicyInterfaceMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)

	// AddClusterScopedFeatureLifecycleFunc mocks the AddClusterScopedFeatureLifecycle method.
	AddClusterScopedFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)

	// AddClusterScopedLifecycleFunc mocks the AddClusterScopedLifecycle method.
	AddClusterScopedLifecycleFunc func(ctx context.Context, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)

	// AddFeatureLifecycleFunc mocks the AddFeatureLifecycle method.
	AddFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, lifecycle v31.ProjectNetworkPolicyLifecycle)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc)

	// AddLifecycleFunc mocks the AddLifecycle method.
	AddLifecycleFunc func(ctx context.Context, name string, lifecycle v31.ProjectNetworkPolicyLifecycle)

	// ControllerFunc mocks the Controller method.
	ControllerFunc func() v31.ProjectNetworkPolicyController

	// CreateFunc mocks the Create method.
	CreateFunc func(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(name string, options *metav1.DeleteOptions) error

	// DeleteCollectionFunc mocks the DeleteCollection method.
	DeleteCollectionFunc func(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error

	// DeleteNamespacedFunc mocks the DeleteNamespaced method.
	DeleteNamespacedFunc func(namespace string, name string, options *metav1.DeleteOptions) error

	// GetFunc mocks the Get method.
	GetFunc func(name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error)

	// GetNamespacedFunc mocks the GetNamespaced method.
	GetNamespacedFunc func(namespace string, name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error)

	// ListFunc mocks the List method.
	ListFunc func(opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error)

	// ListNamespacedFunc mocks the ListNamespaced method.
	ListNamespacedFunc func(namespace string, opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error)

	// ObjectClientFunc mocks the ObjectClient method.
	ObjectClientFunc func() *objectclient.ObjectClient

	// UpdateFunc mocks the Update method.
	UpdateFunc func(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error)

	// WatchFunc mocks the Watch method.
	WatchFunc func(opts metav1.ListOptions) (watch.Interface, error)

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddClusterScopedFeatureLifecycle holds details about calls to the AddClusterScopedFeatureLifecycle method.
		AddClusterScopedFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.ProjectNetworkPolicyLifecycle
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddClusterScopedLifecycle holds details about calls to the AddClusterScopedLifecycle method.
		AddClusterScopedLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.ProjectNetworkPolicyLifecycle
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddFeatureLifecycle holds details about calls to the AddFeatureLifecycle method.
		AddFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.ProjectNetworkPolicyLifecycle
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.ProjectNetworkPolicyHandlerFunc
		}
		// AddLifecycle holds details about calls to the AddLifecycle method.
		AddLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.ProjectNetworkPolicyLifecycle
		}
		// Controller holds details about calls to the Controller method.
		Controller []struct {
		}
		// Create holds details about calls to the Create method.
		Create []struct {
			// In1 is the in1 argument value.
			In1 *v3.ProjectNetworkPolicy
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *metav1.DeleteOptions
		}
		// DeleteCollection holds details about calls to the DeleteCollection method.
		DeleteCollection []struct {
			// DeleteOpts is the deleteOpts argument value.
			DeleteOpts *metav1.DeleteOptions
			// ListOpts is the listOpts argument value.
			ListOpts metav1.ListOptions
		}
		// DeleteNamespaced holds details about calls to the DeleteNamespaced method.
		DeleteNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *metav1.DeleteOptions
		}
		// Get holds details about calls to the Get method.
		Get []struct {
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts metav1.GetOptions
		}
		// GetNamespaced holds details about calls to the GetNamespaced method.
		GetNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts metav1.GetOptions
		}
		// List holds details about calls to the List method.
		List []struct {
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
		// ListNamespaced holds details about calls to the ListNamespaced method.
		ListNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
		// ObjectClient holds details about calls to the ObjectClient method.
		ObjectClient []struct {
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// In1 is the in1 argument value.
			In1 *v3.ProjectNetworkPolicy
		}
		// Watch holds details about calls to the Watch method.
		Watch []struct {
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddClusterScopedFeatureHandlerFunc: method is nil but ProjectNetworkPolicyInterface.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Sync:        syncMoqParam,
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, syncMoqParam)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddClusterScopedFeatureHandlerCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Sync        v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedFeatureLifecycle calls AddClusterScopedFeatureLifecycleFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedFeatureLifecycle(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle) {
	if mock.AddClusterScopedFeatureLifecycleFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddClusterScopedFeatureLifecycleFunc: method is nil but ProjectNetworkPolicyInterface.AddClusterScopedFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v31.ProjectNetworkPolicyLifecycle
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureLifecycle.Lock()
	mock.calls.AddClusterScopedFeatureLifecycle = append(mock.calls.AddClusterScopedFeatureLifecycle, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureLifecycle.Unlock()
	mock.AddClusterScopedFeatureLifecycleFunc(ctx, enabled, name, clusterName, lifecycle)
}

// AddClusterScopedFeatureLifecycleCalls gets all the calls that were made to AddClusterScopedFeatureLifecycle.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddClusterScopedFeatureLifecycleCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedFeatureLifecycleCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Lifecycle   v31.ProjectNetworkPolicyLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v31.ProjectNetworkPolicyLifecycle
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureLifecycle.RLock()
	calls = mock.calls.AddClusterScopedFeatureLifecycle
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedFeatureLifecycle.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddClusterScopedHandlerFunc: method is nil but ProjectNetworkPolicyInterface.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Sync:        syncMoqParam,
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, syncMoqParam)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddClusterScopedHandlerCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Sync        v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddClusterScopedLifecycle calls AddClusterScopedLifecycleFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedLifecycle(ctx context.Context, name string, clusterName string, lifecycle v31.ProjectNetworkPolicyLifecycle) {
	if mock.AddClusterScopedLifecycleFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddClusterScopedLifecycleFunc: method is nil but ProjectNetworkPolicyInterface.AddClusterScopedLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v31.ProjectNetworkPolicyLifecycle
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedLifecycle.Lock()
	mock.calls.AddClusterScopedLifecycle = append(mock.calls.AddClusterScopedLifecycle, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedLifecycle.Unlock()
	mock.AddClusterScopedLifecycleFunc(ctx, name, clusterName, lifecycle)
}

// AddClusterScopedLifecycleCalls gets all the calls that were made to AddClusterScopedLifecycle.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddClusterScopedLifecycleCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddClusterScopedLifecycleCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Lifecycle   v31.ProjectNetworkPolicyLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v31.ProjectNetworkPolicyLifecycle
	}
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedLifecycle.RLock()
	calls = mock.calls.AddClusterScopedLifecycle
	lockProjectNetworkPolicyInterfaceMockAddClusterScopedLifecycle.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddFeatureHandlerFunc: method is nil but ProjectNetworkPolicyInterface.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    syncMoqParam,
	}
	lockProjectNetworkPolicyInterfaceMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, syncMoqParam)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddFeatureHandlerCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyInterfaceMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockProjectNetworkPolicyInterfaceMockAddFeatureHandler.RUnlock()
	return calls
}

// AddFeatureLifecycle calls AddFeatureLifecycleFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddFeatureLifecycle(ctx context.Context, enabled func() bool, name string, lifecycle v31.ProjectNetworkPolicyLifecycle) {
	if mock.AddFeatureLifecycleFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddFeatureLifecycleFunc: method is nil but ProjectNetworkPolicyInterface.AddFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v31.ProjectNetworkPolicyLifecycle
	}{
		Ctx:       ctx,
		Enabled:   enabled,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockProjectNetworkPolicyInterfaceMockAddFeatureLifecycle.Lock()
	mock.calls.AddFeatureLifecycle = append(mock.calls.AddFeatureLifecycle, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddFeatureLifecycle.Unlock()
	mock.AddFeatureLifecycleFunc(ctx, enabled, name, lifecycle)
}

// AddFeatureLifecycleCalls gets all the calls that were made to AddFeatureLifecycle.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddFeatureLifecycleCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddFeatureLifecycleCalls() []struct {
	Ctx       context.Context
	Enabled   func() bool
	Name      string
	Lifecycle v31.ProjectNetworkPolicyLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v31.ProjectNetworkPolicyLifecycle
	}
	lockProjectNetworkPolicyInterfaceMockAddFeatureLifecycle.RLock()
	calls = mock.calls.AddFeatureLifecycle
	lockProjectNetworkPolicyInterfaceMockAddFeatureLifecycle.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddHandler(ctx context.Context, name string, syncMoqParam v31.ProjectNetworkPolicyHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddHandlerFunc: method is nil but ProjectNetworkPolicyInterface.AddHandler was just called")
	}
	callInfo := struct {
		Ctx  context.Context
		Name string
		Sync v31.ProjectNetworkPolicyHandlerFunc
	}{
		Ctx:  ctx,
		Name: name,
		Sync: syncMoqParam,
	}
	lockProjectNetworkPolicyInterfaceMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, syncMoqParam)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddHandlerCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddHandlerCalls() []struct {
	Ctx  context.Context
	Name string
	Sync v31.ProjectNetworkPolicyHandlerFunc
} {
	var calls []struct {
		Ctx  context.Context
		Name string
		Sync v31.ProjectNetworkPolicyHandlerFunc
	}
	lockProjectNetworkPolicyInterfaceMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockProjectNetworkPolicyInterfaceMockAddHandler.RUnlock()
	return calls
}

// AddLifecycle calls AddLifecycleFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) AddLifecycle(ctx context.Context, name string, lifecycle v31.ProjectNetworkPolicyLifecycle) {
	if mock.AddLifecycleFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.AddLifecycleFunc: method is nil but ProjectNetworkPolicyInterface.AddLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Name      string
		Lifecycle v31.ProjectNetworkPolicyLifecycle
	}{
		Ctx:       ctx,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockProjectNetworkPolicyInterfaceMockAddLifecycle.Lock()
	mock.calls.AddLifecycle = append(mock.calls.AddLifecycle, callInfo)
	lockProjectNetworkPolicyInterfaceMockAddLifecycle.Unlock()
	mock.AddLifecycleFunc(ctx, name, lifecycle)
}

// AddLifecycleCalls gets all the calls that were made to AddLifecycle.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.AddLifecycleCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) AddLifecycleCalls() []struct {
	Ctx       context.Context
	Name      string
	Lifecycle v31.ProjectNetworkPolicyLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Name      string
		Lifecycle v31.ProjectNetworkPolicyLifecycle
	}
	lockProjectNetworkPolicyInterfaceMockAddLifecycle.RLock()
	calls = mock.calls.AddLifecycle
	lockProjectNetworkPolicyInterfaceMockAddLifecycle.RUnlock()
	return calls
}

// Controller calls ControllerFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Controller() v31.ProjectNetworkPolicyController {
	if mock.ControllerFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.ControllerFunc: method is nil but ProjectNetworkPolicyInterface.Controller was just called")
	}
	callInfo := struct {
	}{}
	lockProjectNetworkPolicyInterfaceMockController.Lock()
	mock.calls.Controller = append(mock.calls.Controller, callInfo)
	lockProjectNetworkPolicyInterfaceMockController.Unlock()
	return mock.ControllerFunc()
}

// ControllerCalls gets all the calls that were made to Controller.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.ControllerCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) ControllerCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectNetworkPolicyInterfaceMockController.RLock()
	calls = mock.calls.Controller
	lockProjectNetworkPolicyInterfaceMockController.RUnlock()
	return calls
}

// Create calls CreateFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Create(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error) {
	if mock.CreateFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.CreateFunc: method is nil but ProjectNetworkPolicyInterface.Create was just called")
	}
	callInfo := struct {
		In1 *v3.ProjectNetworkPolicy
	}{
		In1: in1,
	}
	lockProjectNetworkPolicyInterfaceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockProjectNetworkPolicyInterfaceMockCreate.Unlock()
	return mock.CreateFunc(in1)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.CreateCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) CreateCalls() []struct {
	In1 *v3.ProjectNetworkPolicy
} {
	var calls []struct {
		In1 *v3.ProjectNetworkPolicy
	}
	lockProjectNetworkPolicyInterfaceMockCreate.RLock()
	calls = mock.calls.Create
	lockProjectNetworkPolicyInterfaceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Delete(name string, options *metav1.DeleteOptions) error {
	if mock.DeleteFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.DeleteFunc: method is nil but ProjectNetworkPolicyInterface.Delete was just called")
	}
	callInfo := struct {
		Name    string
		Options *metav1.DeleteOptions
	}{
		Name:    name,
		Options: options,
	}
	lockProjectNetworkPolicyInterfaceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockProjectNetworkPolicyInterfaceMockDelete.Unlock()
	return mock.DeleteFunc(name, options)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.DeleteCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) DeleteCalls() []struct {
	Name    string
	Options *metav1.DeleteOptions
} {
	var calls []struct {
		Name    string
		Options *metav1.DeleteOptions
	}
	lockProjectNetworkPolicyInterfaceMockDelete.RLock()
	calls = mock.calls.Delete
	lockProjectNetworkPolicyInterfaceMockDelete.RUnlock()
	return calls
}

// DeleteCollection calls DeleteCollectionFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) DeleteCollection(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	if mock.DeleteCollectionFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.DeleteCollectionFunc: method is nil but ProjectNetworkPolicyInterface.DeleteCollection was just called")
	}
	callInfo := struct {
		DeleteOpts *metav1.DeleteOptions
		ListOpts   metav1.ListOptions
	}{
		DeleteOpts: deleteOpts,
		ListOpts:   listOpts,
	}
	lockProjectNetworkPolicyInterfaceMockDeleteCollection.Lock()
	mock.calls.DeleteCollection = append(mock.calls.DeleteCollection, callInfo)
	lockProjectNetworkPolicyInterfaceMockDeleteCollection.Unlock()
	return mock.DeleteCollectionFunc(deleteOpts, listOpts)
}

// DeleteCollectionCalls gets all the calls that were made to DeleteCollection.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.DeleteCollectionCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) DeleteCollectionCalls() []struct {
	DeleteOpts *metav1.DeleteOptions
	ListOpts   metav1.ListOptions
} {
	var calls []struct {
		DeleteOpts *metav1.DeleteOptions
		ListOpts   metav1.ListOptions
	}
	lockProjectNetworkPolicyInterfaceMockDeleteCollection.RLock()
	calls = mock.calls.DeleteCollection
	lockProjectNetworkPolicyInterfaceMockDeleteCollection.RUnlock()
	return calls
}

// DeleteNamespaced calls DeleteNamespacedFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) DeleteNamespaced(namespace string, name string, options *metav1.DeleteOptions) error {
	if mock.DeleteNamespacedFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.DeleteNamespacedFunc: method is nil but ProjectNetworkPolicyInterface.DeleteNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Options   *metav1.DeleteOptions
	}{
		Namespace: namespace,
		Name:      name,
		Options:   options,
	}
	lockProjectNetworkPolicyInterfaceMockDeleteNamespaced.Lock()
	mock.calls.DeleteNamespaced = append(mock.calls.DeleteNamespaced, callInfo)
	lockProjectNetworkPolicyInterfaceMockDeleteNamespaced.Unlock()
	return mock.DeleteNamespacedFunc(namespace, name, options)
}

// DeleteNamespacedCalls gets all the calls that were made to DeleteNamespaced.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.DeleteNamespacedCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) DeleteNamespacedCalls() []struct {
	Namespace string
	Name      string
	Options   *metav1.DeleteOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Options   *metav1.DeleteOptions
	}
	lockProjectNetworkPolicyInterfaceMockDeleteNamespaced.RLock()
	calls = mock.calls.DeleteNamespaced
	lockProjectNetworkPolicyInterfaceMockDeleteNamespaced.RUnlock()
	return calls
}

// Get calls GetFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Get(name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error) {
	if mock.GetFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.GetFunc: method is nil but ProjectNetworkPolicyInterface.Get was just called")
	}
	callInfo := struct {
		Name string
		Opts metav1.GetOptions
	}{
		Name: name,
		Opts: opts,
	}
	lockProjectNetworkPolicyInterfaceMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockProjectNetworkPolicyInterfaceMockGet.Unlock()
	return mock.GetFunc(name, opts)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.GetCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) GetCalls() []struct {
	Name string
	Opts metav1.GetOptions
} {
	var calls []struct {
		Name string
		Opts metav1.GetOptions
	}
	lockProjectNetworkPolicyInterfaceMockGet.RLock()
	calls = mock.calls.Get
	lockProjectNetworkPolicyInterfaceMockGet.RUnlock()
	return calls
}

// GetNamespaced calls GetNamespacedFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) GetNamespaced(namespace string, name string, opts metav1.GetOptions) (*v3.ProjectNetworkPolicy, error) {
	if mock.GetNamespacedFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.GetNamespacedFunc: method is nil but ProjectNetworkPolicyInterface.GetNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Opts      metav1.GetOptions
	}{
		Namespace: namespace,
		Name:      name,
		Opts:      opts,
	}
	lockProjectNetworkPolicyInterfaceMockGetNamespaced.Lock()
	mock.calls.GetNamespaced = append(mock.calls.GetNamespaced, callInfo)
	lockProjectNetworkPolicyInterfaceMockGetNamespaced.Unlock()
	return mock.GetNamespacedFunc(namespace, name, opts)
}

// GetNamespacedCalls gets all the calls that were made to GetNamespaced.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.GetNamespacedCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) GetNamespacedCalls() []struct {
	Namespace string
	Name      string
	Opts      metav1.GetOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Opts      metav1.GetOptions
	}
	lockProjectNetworkPolicyInterfaceMockGetNamespaced.RLock()
	calls = mock.calls.GetNamespaced
	lockProjectNetworkPolicyInterfaceMockGetNamespaced.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) List(opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error) {
	if mock.ListFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.ListFunc: method is nil but ProjectNetworkPolicyInterface.List was just called")
	}
	callInfo := struct {
		Opts metav1.ListOptions
	}{
		Opts: opts,
	}
	lockProjectNetworkPolicyInterfaceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockProjectNetworkPolicyInterfaceMockList.Unlock()
	return mock.ListFunc(opts)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.ListCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) ListCalls() []struct {
	Opts metav1.ListOptions
} {
	var calls []struct {
		Opts metav1.ListOptions
	}
	lockProjectNetworkPolicyInterfaceMockList.RLock()
	calls = mock.calls.List
	lockProjectNetworkPolicyInterfaceMockList.RUnlock()
	return calls
}

// ListNamespaced calls ListNamespacedFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) ListNamespaced(namespace string, opts metav1.ListOptions) (*v3.ProjectNetworkPolicyList, error) {
	if mock.ListNamespacedFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.ListNamespacedFunc: method is nil but ProjectNetworkPolicyInterface.ListNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Opts      metav1.ListOptions
	}{
		Namespace: namespace,
		Opts:      opts,
	}
	lockProjectNetworkPolicyInterfaceMockListNamespaced.Lock()
	mock.calls.ListNamespaced = append(mock.calls.ListNamespaced, callInfo)
	lockProjectNetworkPolicyInterfaceMockListNamespaced.Unlock()
	return mock.ListNamespacedFunc(namespace, opts)
}

// ListNamespacedCalls gets all the calls that were made to ListNamespaced.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.ListNamespacedCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) ListNamespacedCalls() []struct {
	Namespace string
	Opts      metav1.ListOptions
} {
	var calls []struct {
		Namespace string
		Opts      metav1.ListOptions
	}
	lockProjectNetworkPolicyInterfaceMockListNamespaced.RLock()
	calls = mock.calls.ListNamespaced
	lockProjectNetworkPolicyInterfaceMockListNamespaced.RUnlock()
	return calls
}

// ObjectClient calls ObjectClientFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) ObjectClient() *objectclient.ObjectClient {
	if mock.ObjectClientFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.ObjectClientFunc: method is nil but ProjectNetworkPolicyInterface.ObjectClient was just called")
	}
	callInfo := struct {
	}{}
	lockProjectNetworkPolicyInterfaceMockObjectClient.Lock()
	mock.calls.ObjectClient = append(mock.calls.ObjectClient, callInfo)
	lockProjectNetworkPolicyInterfaceMockObjectClient.Unlock()
	return mock.ObjectClientFunc()
}

// ObjectClientCalls gets all the calls that were made to ObjectClient.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.ObjectClientCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) ObjectClientCalls() []struct {
} {
	var calls []struct {
	}
	lockProjectNetworkPolicyInterfaceMockObjectClient.RLock()
	calls = mock.calls.ObjectClient
	lockProjectNetworkPolicyInterfaceMockObjectClient.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Update(in1 *v3.ProjectNetworkPolicy) (*v3.ProjectNetworkPolicy, error) {
	if mock.UpdateFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.UpdateFunc: method is nil but ProjectNetworkPolicyInterface.Update was just called")
	}
	callInfo := struct {
		In1 *v3.ProjectNetworkPolicy
	}{
		In1: in1,
	}
	lockProjectNetworkPolicyInterfaceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockProjectNetworkPolicyInterfaceMockUpdate.Unlock()
	return mock.UpdateFunc(in1)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.UpdateCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) UpdateCalls() []struct {
	In1 *v3.ProjectNetworkPolicy
} {
	var calls []struct {
		In1 *v3.ProjectNetworkPolicy
	}
	lockProjectNetworkPolicyInterfaceMockUpdate.RLock()
	calls = mock.calls.Update
	lockProjectNetworkPolicyInterfaceMockUpdate.RUnlock()
	return calls
}

// Watch calls WatchFunc.
func (mock *ProjectNetworkPolicyInterfaceMock) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	if mock.WatchFunc == nil {
		panic("ProjectNetworkPolicyInterfaceMock.WatchFunc: method is nil but ProjectNetworkPolicyInterface.Watch was just called")
	}
	callInfo := struct {
		Opts metav1.ListOptions
	}{
		Opts: opts,
	}
	lockProjectNetworkPolicyInterfaceMockWatch.Lock()
	mock.calls.Watch = append(mock.calls.Watch, callInfo)
	lockProjectNetworkPolicyInterfaceMockWatch.Unlock()
	return mock.WatchFunc(opts)
}

// WatchCalls gets all the calls that were made to Watch.
// Check the length with:
//     len(mockedProjectNetworkPolicyInterface.WatchCalls())
func (mock *ProjectNetworkPolicyInterfaceMock) WatchCalls() []struct {
	Opts metav1.ListOptions
} {
	var calls []struct {
		Opts metav1.ListOptions
	}
	lockProjectNetworkPolicyInterfaceMockWatch.RLock()
	calls = mock.calls.Watch
	lockProjectNetworkPolicyInterfaceMockWatch.RUnlock()
	return calls
}

var (
	lockProjectNetworkPoliciesGetterMockProjectNetworkPolicies sync.RWMutex
)

// Ensure, that ProjectNetworkPoliciesGetterMock does implement v31.ProjectNetworkPoliciesGetter.
// If this is not the case, regenerate this file with moq.
var _ v31.ProjectNetworkPoliciesGetter = &ProjectNetworkPoliciesGetterMock{}

// ProjectNetworkPoliciesGetterMock is a mock implementation of v31.ProjectNetworkPoliciesGetter.
//
//     func TestSomethingThatUsesProjectNetworkPoliciesGetter(t *testing.T) {
//
//         // make and configure a mocked v31.ProjectNetworkPoliciesGetter
//         mockedProjectNetworkPoliciesGetter := &ProjectNetworkPoliciesGetterMock{
//             ProjectNetworkPoliciesFunc: func(namespace string) v31.ProjectNetworkPolicyInterface {
// 	               panic("mock out the ProjectNetworkPolicies method")
//             },
//         }
//
//         // use mockedProjectNetworkPoliciesGetter in code that requires v31.ProjectNetworkPoliciesGetter
//         // and then make assertions.
//
//     }
type ProjectNetworkPoliciesGetterMock struct {
	// ProjectNetworkPoliciesFunc mocks the ProjectNetworkPolicies method.
	ProjectNetworkPoliciesFunc func(namespace string) v31.ProjectNetworkPolicyInterface

	// calls tracks calls to the methods.
	calls struct {
		// ProjectNetworkPolicies holds details about calls to the ProjectNetworkPolicies method.
		ProjectNetworkPolicies []struct {
			// Namespace is the namespace argument value.
			Namespace string
		}
	}
}

// ProjectNetworkPolicies calls ProjectNetworkPoliciesFunc.
func (mock *ProjectNetworkPoliciesGetterMock) ProjectNetworkPolicies(namespace string) v31.ProjectNetworkPolicyInterface {
	if mock.ProjectNetworkPoliciesFunc == nil {
		panic("ProjectNetworkPoliciesGetterMock.ProjectNetworkPoliciesFunc: method is nil but ProjectNetworkPoliciesGetter.ProjectNetworkPolicies was just called")
	}
	callInfo := struct {
		Namespace string
	}{
		Namespace: namespace,
	}
	lockProjectNetworkPoliciesGetterMockProjectNetworkPolicies.Lock()
	mock.calls.ProjectNetworkPolicies = append(mock.calls.ProjectNetworkPolicies, callInfo)
	lockProjectNetworkPoliciesGetterMockProjectNetworkPolicies.Unlock()
	return mock.ProjectNetworkPoliciesFunc(namespace)
}

// ProjectNetworkPoliciesCalls gets all the calls that were made to ProjectNetworkPolicies.
// Check the length with:
//     len(mockedProjectNetworkPoliciesGetter.ProjectNetworkPoliciesCalls())
func (mock *ProjectNetworkPoliciesGetterMock) ProjectNetworkPoliciesCalls() []struct {
	Namespace string
} {
	var calls []struct {
		Namespace string
	}
	lockProjectNetworkPoliciesGetterMockProjectNetworkPolicies.RLock()
	calls = mock.calls.ProjectNetworkPolicies
	lockProjectNetworkPoliciesGetterMockProjectNetworkPolicies.RUnlock()
	return calls
}
