// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package fakes

import (
	"context"
	"sync"
	"time"

	"github.com/rancher/norman/controller"
	"github.com/rancher/norman/objectclient"
	v3 "github.com/rancher/rancher/pkg/apis/project.cattle.io/v3"
	v31 "github.com/rancher/rancher/pkg/generated/norman/project.cattle.io/v3"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/apimachinery/pkg/watch"
	"k8s.io/client-go/tools/cache"
)

var (
	lockSourceCodeCredentialListerMockGet  sync.RWMutex
	lockSourceCodeCredentialListerMockList sync.RWMutex
)

// Ensure, that SourceCodeCredentialListerMock does implement v31.SourceCodeCredentialLister.
// If this is not the case, regenerate this file with moq.
var _ v31.SourceCodeCredentialLister = &SourceCodeCredentialListerMock{}

// SourceCodeCredentialListerMock is a mock implementation of v31.SourceCodeCredentialLister.
//
//     func TestSomethingThatUsesSourceCodeCredentialLister(t *testing.T) {
//
//         // make and configure a mocked v31.SourceCodeCredentialLister
//         mockedSourceCodeCredentialLister := &SourceCodeCredentialListerMock{
//             GetFunc: func(namespace string, name string) (*v3.SourceCodeCredential, error) {
// 	               panic("mock out the Get method")
//             },
//             ListFunc: func(namespace string, selector labels.Selector) ([]*v3.SourceCodeCredential, error) {
// 	               panic("mock out the List method")
//             },
//         }
//
//         // use mockedSourceCodeCredentialLister in code that requires v31.SourceCodeCredentialLister
//         // and then make assertions.
//
//     }
type SourceCodeCredentialListerMock struct {
	// GetFunc mocks the Get method.
	GetFunc func(namespace string, name string) (*v3.SourceCodeCredential, error)

	// ListFunc mocks the List method.
	ListFunc func(namespace string, selector labels.Selector) ([]*v3.SourceCodeCredential, error)

	// calls tracks calls to the methods.
	calls struct {
		// Get holds details about calls to the Get method.
		Get []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Selector is the selector argument value.
			Selector labels.Selector
		}
	}
}

// Get calls GetFunc.
func (mock *SourceCodeCredentialListerMock) Get(namespace string, name string) (*v3.SourceCodeCredential, error) {
	if mock.GetFunc == nil {
		panic("SourceCodeCredentialListerMock.GetFunc: method is nil but SourceCodeCredentialLister.Get was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockSourceCodeCredentialListerMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockSourceCodeCredentialListerMockGet.Unlock()
	return mock.GetFunc(namespace, name)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedSourceCodeCredentialLister.GetCalls())
func (mock *SourceCodeCredentialListerMock) GetCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockSourceCodeCredentialListerMockGet.RLock()
	calls = mock.calls.Get
	lockSourceCodeCredentialListerMockGet.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *SourceCodeCredentialListerMock) List(namespace string, selector labels.Selector) ([]*v3.SourceCodeCredential, error) {
	if mock.ListFunc == nil {
		panic("SourceCodeCredentialListerMock.ListFunc: method is nil but SourceCodeCredentialLister.List was just called")
	}
	callInfo := struct {
		Namespace string
		Selector  labels.Selector
	}{
		Namespace: namespace,
		Selector:  selector,
	}
	lockSourceCodeCredentialListerMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockSourceCodeCredentialListerMockList.Unlock()
	return mock.ListFunc(namespace, selector)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedSourceCodeCredentialLister.ListCalls())
func (mock *SourceCodeCredentialListerMock) ListCalls() []struct {
	Namespace string
	Selector  labels.Selector
} {
	var calls []struct {
		Namespace string
		Selector  labels.Selector
	}
	lockSourceCodeCredentialListerMockList.RLock()
	calls = mock.calls.List
	lockSourceCodeCredentialListerMockList.RUnlock()
	return calls
}

var (
	lockSourceCodeCredentialControllerMockAddClusterScopedFeatureHandler sync.RWMutex
	lockSourceCodeCredentialControllerMockAddClusterScopedHandler        sync.RWMutex
	lockSourceCodeCredentialControllerMockAddFeatureHandler              sync.RWMutex
	lockSourceCodeCredentialControllerMockAddHandler                     sync.RWMutex
	lockSourceCodeCredentialControllerMockEnqueue                        sync.RWMutex
	lockSourceCodeCredentialControllerMockEnqueueAfter                   sync.RWMutex
	lockSourceCodeCredentialControllerMockGeneric                        sync.RWMutex
	lockSourceCodeCredentialControllerMockInformer                       sync.RWMutex
	lockSourceCodeCredentialControllerMockLister                         sync.RWMutex
)

// Ensure, that SourceCodeCredentialControllerMock does implement v31.SourceCodeCredentialController.
// If this is not the case, regenerate this file with moq.
var _ v31.SourceCodeCredentialController = &SourceCodeCredentialControllerMock{}

// SourceCodeCredentialControllerMock is a mock implementation of v31.SourceCodeCredentialController.
//
//     func TestSomethingThatUsesSourceCodeCredentialController(t *testing.T) {
//
//         // make and configure a mocked v31.SourceCodeCredentialController
//         mockedSourceCodeCredentialController := &SourceCodeCredentialControllerMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, handler v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             EnqueueFunc: func(namespace string, name string)  {
// 	               panic("mock out the Enqueue method")
//             },
//             EnqueueAfterFunc: func(namespace string, name string, after time.Duration)  {
// 	               panic("mock out the EnqueueAfter method")
//             },
//             GenericFunc: func() controller.GenericController {
// 	               panic("mock out the Generic method")
//             },
//             InformerFunc: func() cache.SharedIndexInformer {
// 	               panic("mock out the Informer method")
//             },
//             ListerFunc: func() v31.SourceCodeCredentialLister {
// 	               panic("mock out the Lister method")
//             },
//         }
//
//         // use mockedSourceCodeCredentialController in code that requires v31.SourceCodeCredentialController
//         // and then make assertions.
//
//     }
type SourceCodeCredentialControllerMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, handler v31.SourceCodeCredentialHandlerFunc)

	// EnqueueFunc mocks the Enqueue method.
	EnqueueFunc func(namespace string, name string)

	// EnqueueAfterFunc mocks the EnqueueAfter method.
	EnqueueAfterFunc func(namespace string, name string, after time.Duration)

	// GenericFunc mocks the Generic method.
	GenericFunc func() controller.GenericController

	// InformerFunc mocks the Informer method.
	InformerFunc func() cache.SharedIndexInformer

	// ListerFunc mocks the Lister method.
	ListerFunc func() v31.SourceCodeCredentialLister

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v31.SourceCodeCredentialHandlerFunc
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v31.SourceCodeCredentialHandlerFunc
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.SourceCodeCredentialHandlerFunc
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Handler is the handler argument value.
			Handler v31.SourceCodeCredentialHandlerFunc
		}
		// Enqueue holds details about calls to the Enqueue method.
		Enqueue []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// EnqueueAfter holds details about calls to the EnqueueAfter method.
		EnqueueAfter []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// After is the after argument value.
			After time.Duration
		}
		// Generic holds details about calls to the Generic method.
		Generic []struct {
		}
		// Informer holds details about calls to the Informer method.
		Informer []struct {
		}
		// Lister holds details about calls to the Lister method.
		Lister []struct {
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *SourceCodeCredentialControllerMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("SourceCodeCredentialControllerMock.AddClusterScopedFeatureHandlerFunc: method is nil but SourceCodeCredentialController.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockSourceCodeCredentialControllerMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockSourceCodeCredentialControllerMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, handler)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialController.AddClusterScopedFeatureHandlerCalls())
func (mock *SourceCodeCredentialControllerMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Handler     v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialControllerMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockSourceCodeCredentialControllerMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *SourceCodeCredentialControllerMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, handler v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("SourceCodeCredentialControllerMock.AddClusterScopedHandlerFunc: method is nil but SourceCodeCredentialController.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockSourceCodeCredentialControllerMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockSourceCodeCredentialControllerMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, handler)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialController.AddClusterScopedHandlerCalls())
func (mock *SourceCodeCredentialControllerMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Handler     v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialControllerMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockSourceCodeCredentialControllerMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *SourceCodeCredentialControllerMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("SourceCodeCredentialControllerMock.AddFeatureHandlerFunc: method is nil but SourceCodeCredentialController.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    syncMoqParam,
	}
	lockSourceCodeCredentialControllerMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockSourceCodeCredentialControllerMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, syncMoqParam)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialController.AddFeatureHandlerCalls())
func (mock *SourceCodeCredentialControllerMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialControllerMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockSourceCodeCredentialControllerMockAddFeatureHandler.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *SourceCodeCredentialControllerMock) AddHandler(ctx context.Context, name string, handler v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("SourceCodeCredentialControllerMock.AddHandlerFunc: method is nil but SourceCodeCredentialController.AddHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Name    string
		Handler v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:     ctx,
		Name:    name,
		Handler: handler,
	}
	lockSourceCodeCredentialControllerMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockSourceCodeCredentialControllerMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, handler)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialController.AddHandlerCalls())
func (mock *SourceCodeCredentialControllerMock) AddHandlerCalls() []struct {
	Ctx     context.Context
	Name    string
	Handler v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Name    string
		Handler v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialControllerMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockSourceCodeCredentialControllerMockAddHandler.RUnlock()
	return calls
}

// Enqueue calls EnqueueFunc.
func (mock *SourceCodeCredentialControllerMock) Enqueue(namespace string, name string) {
	if mock.EnqueueFunc == nil {
		panic("SourceCodeCredentialControllerMock.EnqueueFunc: method is nil but SourceCodeCredentialController.Enqueue was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockSourceCodeCredentialControllerMockEnqueue.Lock()
	mock.calls.Enqueue = append(mock.calls.Enqueue, callInfo)
	lockSourceCodeCredentialControllerMockEnqueue.Unlock()
	mock.EnqueueFunc(namespace, name)
}

// EnqueueCalls gets all the calls that were made to Enqueue.
// Check the length with:
//     len(mockedSourceCodeCredentialController.EnqueueCalls())
func (mock *SourceCodeCredentialControllerMock) EnqueueCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockSourceCodeCredentialControllerMockEnqueue.RLock()
	calls = mock.calls.Enqueue
	lockSourceCodeCredentialControllerMockEnqueue.RUnlock()
	return calls
}

// EnqueueAfter calls EnqueueAfterFunc.
func (mock *SourceCodeCredentialControllerMock) EnqueueAfter(namespace string, name string, after time.Duration) {
	if mock.EnqueueAfterFunc == nil {
		panic("SourceCodeCredentialControllerMock.EnqueueAfterFunc: method is nil but SourceCodeCredentialController.EnqueueAfter was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		After     time.Duration
	}{
		Namespace: namespace,
		Name:      name,
		After:     after,
	}
	lockSourceCodeCredentialControllerMockEnqueueAfter.Lock()
	mock.calls.EnqueueAfter = append(mock.calls.EnqueueAfter, callInfo)
	lockSourceCodeCredentialControllerMockEnqueueAfter.Unlock()
	mock.EnqueueAfterFunc(namespace, name, after)
}

// EnqueueAfterCalls gets all the calls that were made to EnqueueAfter.
// Check the length with:
//     len(mockedSourceCodeCredentialController.EnqueueAfterCalls())
func (mock *SourceCodeCredentialControllerMock) EnqueueAfterCalls() []struct {
	Namespace string
	Name      string
	After     time.Duration
} {
	var calls []struct {
		Namespace string
		Name      string
		After     time.Duration
	}
	lockSourceCodeCredentialControllerMockEnqueueAfter.RLock()
	calls = mock.calls.EnqueueAfter
	lockSourceCodeCredentialControllerMockEnqueueAfter.RUnlock()
	return calls
}

// Generic calls GenericFunc.
func (mock *SourceCodeCredentialControllerMock) Generic() controller.GenericController {
	if mock.GenericFunc == nil {
		panic("SourceCodeCredentialControllerMock.GenericFunc: method is nil but SourceCodeCredentialController.Generic was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeCredentialControllerMockGeneric.Lock()
	mock.calls.Generic = append(mock.calls.Generic, callInfo)
	lockSourceCodeCredentialControllerMockGeneric.Unlock()
	return mock.GenericFunc()
}

// GenericCalls gets all the calls that were made to Generic.
// Check the length with:
//     len(mockedSourceCodeCredentialController.GenericCalls())
func (mock *SourceCodeCredentialControllerMock) GenericCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeCredentialControllerMockGeneric.RLock()
	calls = mock.calls.Generic
	lockSourceCodeCredentialControllerMockGeneric.RUnlock()
	return calls
}

// Informer calls InformerFunc.
func (mock *SourceCodeCredentialControllerMock) Informer() cache.SharedIndexInformer {
	if mock.InformerFunc == nil {
		panic("SourceCodeCredentialControllerMock.InformerFunc: method is nil but SourceCodeCredentialController.Informer was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeCredentialControllerMockInformer.Lock()
	mock.calls.Informer = append(mock.calls.Informer, callInfo)
	lockSourceCodeCredentialControllerMockInformer.Unlock()
	return mock.InformerFunc()
}

// InformerCalls gets all the calls that were made to Informer.
// Check the length with:
//     len(mockedSourceCodeCredentialController.InformerCalls())
func (mock *SourceCodeCredentialControllerMock) InformerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeCredentialControllerMockInformer.RLock()
	calls = mock.calls.Informer
	lockSourceCodeCredentialControllerMockInformer.RUnlock()
	return calls
}

// Lister calls ListerFunc.
func (mock *SourceCodeCredentialControllerMock) Lister() v31.SourceCodeCredentialLister {
	if mock.ListerFunc == nil {
		panic("SourceCodeCredentialControllerMock.ListerFunc: method is nil but SourceCodeCredentialController.Lister was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeCredentialControllerMockLister.Lock()
	mock.calls.Lister = append(mock.calls.Lister, callInfo)
	lockSourceCodeCredentialControllerMockLister.Unlock()
	return mock.ListerFunc()
}

// ListerCalls gets all the calls that were made to Lister.
// Check the length with:
//     len(mockedSourceCodeCredentialController.ListerCalls())
func (mock *SourceCodeCredentialControllerMock) ListerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeCredentialControllerMockLister.RLock()
	calls = mock.calls.Lister
	lockSourceCodeCredentialControllerMockLister.RUnlock()
	return calls
}

var (
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureHandler   sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureLifecycle sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddClusterScopedHandler          sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddClusterScopedLifecycle        sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddFeatureHandler                sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddFeatureLifecycle              sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddHandler                       sync.RWMutex
	lockSourceCodeCredentialInterfaceMockAddLifecycle                     sync.RWMutex
	lockSourceCodeCredentialInterfaceMockController                       sync.RWMutex
	lockSourceCodeCredentialInterfaceMockCreate                           sync.RWMutex
	lockSourceCodeCredentialInterfaceMockDelete                           sync.RWMutex
	lockSourceCodeCredentialInterfaceMockDeleteCollection                 sync.RWMutex
	lockSourceCodeCredentialInterfaceMockDeleteNamespaced                 sync.RWMutex
	lockSourceCodeCredentialInterfaceMockGet                              sync.RWMutex
	lockSourceCodeCredentialInterfaceMockGetNamespaced                    sync.RWMutex
	lockSourceCodeCredentialInterfaceMockList                             sync.RWMutex
	lockSourceCodeCredentialInterfaceMockListNamespaced                   sync.RWMutex
	lockSourceCodeCredentialInterfaceMockObjectClient                     sync.RWMutex
	lockSourceCodeCredentialInterfaceMockUpdate                           sync.RWMutex
	lockSourceCodeCredentialInterfaceMockWatch                            sync.RWMutex
)

// Ensure, that SourceCodeCredentialInterfaceMock does implement v31.SourceCodeCredentialInterface.
// If this is not the case, regenerate this file with moq.
var _ v31.SourceCodeCredentialInterface = &SourceCodeCredentialInterfaceMock{}

// SourceCodeCredentialInterfaceMock is a mock implementation of v31.SourceCodeCredentialInterface.
//
//     func TestSomethingThatUsesSourceCodeCredentialInterface(t *testing.T) {
//
//         // make and configure a mocked v31.SourceCodeCredentialInterface
//         mockedSourceCodeCredentialInterface := &SourceCodeCredentialInterfaceMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle)  {
// 	               panic("mock out the AddClusterScopedFeatureLifecycle method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddClusterScopedLifecycleFunc: func(ctx context.Context, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle)  {
// 	               panic("mock out the AddClusterScopedLifecycle method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, lifecycle v31.SourceCodeCredentialLifecycle)  {
// 	               panic("mock out the AddFeatureLifecycle method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             AddLifecycleFunc: func(ctx context.Context, name string, lifecycle v31.SourceCodeCredentialLifecycle)  {
// 	               panic("mock out the AddLifecycle method")
//             },
//             ControllerFunc: func() v31.SourceCodeCredentialController {
// 	               panic("mock out the Controller method")
//             },
//             CreateFunc: func(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(name string, options *metav1.DeleteOptions) error {
// 	               panic("mock out the Delete method")
//             },
//             DeleteCollectionFunc: func(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error {
// 	               panic("mock out the DeleteCollection method")
//             },
//             DeleteNamespacedFunc: func(namespace string, name string, options *metav1.DeleteOptions) error {
// 	               panic("mock out the DeleteNamespaced method")
//             },
//             GetFunc: func(name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error) {
// 	               panic("mock out the Get method")
//             },
//             GetNamespacedFunc: func(namespace string, name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error) {
// 	               panic("mock out the GetNamespaced method")
//             },
//             ListFunc: func(opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error) {
// 	               panic("mock out the List method")
//             },
//             ListNamespacedFunc: func(namespace string, opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error) {
// 	               panic("mock out the ListNamespaced method")
//             },
//             ObjectClientFunc: func() *objectclient.ObjectClient {
// 	               panic("mock out the ObjectClient method")
//             },
//             UpdateFunc: func(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error) {
// 	               panic("mock out the Update method")
//             },
//             WatchFunc: func(opts metav1.ListOptions) (watch.Interface, error) {
// 	               panic("mock out the Watch method")
//             },
//         }
//
//         // use mockedSourceCodeCredentialInterface in code that requires v31.SourceCodeCredentialInterface
//         // and then make assertions.
//
//     }
type SourceCodeCredentialInterfaceMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)

	// AddClusterScopedFeatureLifecycleFunc mocks the AddClusterScopedFeatureLifecycle method.
	AddClusterScopedFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)

	// AddClusterScopedLifecycleFunc mocks the AddClusterScopedLifecycle method.
	AddClusterScopedLifecycleFunc func(ctx context.Context, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)

	// AddFeatureLifecycleFunc mocks the AddFeatureLifecycle method.
	AddFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, lifecycle v31.SourceCodeCredentialLifecycle)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc)

	// AddLifecycleFunc mocks the AddLifecycle method.
	AddLifecycleFunc func(ctx context.Context, name string, lifecycle v31.SourceCodeCredentialLifecycle)

	// ControllerFunc mocks the Controller method.
	ControllerFunc func() v31.SourceCodeCredentialController

	// CreateFunc mocks the Create method.
	CreateFunc func(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(name string, options *metav1.DeleteOptions) error

	// DeleteCollectionFunc mocks the DeleteCollection method.
	DeleteCollectionFunc func(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error

	// DeleteNamespacedFunc mocks the DeleteNamespaced method.
	DeleteNamespacedFunc func(namespace string, name string, options *metav1.DeleteOptions) error

	// GetFunc mocks the Get method.
	GetFunc func(name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error)

	// GetNamespacedFunc mocks the GetNamespaced method.
	GetNamespacedFunc func(namespace string, name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error)

	// ListFunc mocks the List method.
	ListFunc func(opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error)

	// ListNamespacedFunc mocks the ListNamespaced method.
	ListNamespacedFunc func(namespace string, opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error)

	// ObjectClientFunc mocks the ObjectClient method.
	ObjectClientFunc func() *objectclient.ObjectClient

	// UpdateFunc mocks the Update method.
	UpdateFunc func(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error)

	// WatchFunc mocks the Watch method.
	WatchFunc func(opts metav1.ListOptions) (watch.Interface, error)

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v31.SourceCodeCredentialHandlerFunc
		}
		// AddClusterScopedFeatureLifecycle holds details about calls to the AddClusterScopedFeatureLifecycle method.
		AddClusterScopedFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.SourceCodeCredentialLifecycle
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v31.SourceCodeCredentialHandlerFunc
		}
		// AddClusterScopedLifecycle holds details about calls to the AddClusterScopedLifecycle method.
		AddClusterScopedLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.SourceCodeCredentialLifecycle
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.SourceCodeCredentialHandlerFunc
		}
		// AddFeatureLifecycle holds details about calls to the AddFeatureLifecycle method.
		AddFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.SourceCodeCredentialLifecycle
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v31.SourceCodeCredentialHandlerFunc
		}
		// AddLifecycle holds details about calls to the AddLifecycle method.
		AddLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v31.SourceCodeCredentialLifecycle
		}
		// Controller holds details about calls to the Controller method.
		Controller []struct {
		}
		// Create holds details about calls to the Create method.
		Create []struct {
			// In1 is the in1 argument value.
			In1 *v3.SourceCodeCredential
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *metav1.DeleteOptions
		}
		// DeleteCollection holds details about calls to the DeleteCollection method.
		DeleteCollection []struct {
			// DeleteOpts is the deleteOpts argument value.
			DeleteOpts *metav1.DeleteOptions
			// ListOpts is the listOpts argument value.
			ListOpts metav1.ListOptions
		}
		// DeleteNamespaced holds details about calls to the DeleteNamespaced method.
		DeleteNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *metav1.DeleteOptions
		}
		// Get holds details about calls to the Get method.
		Get []struct {
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts metav1.GetOptions
		}
		// GetNamespaced holds details about calls to the GetNamespaced method.
		GetNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts metav1.GetOptions
		}
		// List holds details about calls to the List method.
		List []struct {
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
		// ListNamespaced holds details about calls to the ListNamespaced method.
		ListNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
		// ObjectClient holds details about calls to the ObjectClient method.
		ObjectClient []struct {
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// In1 is the in1 argument value.
			In1 *v3.SourceCodeCredential
		}
		// Watch holds details about calls to the Watch method.
		Watch []struct {
			// Opts is the opts argument value.
			Opts metav1.ListOptions
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddClusterScopedFeatureHandlerFunc: method is nil but SourceCodeCredentialInterface.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Sync:        syncMoqParam,
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, syncMoqParam)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddClusterScopedFeatureHandlerCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Sync        v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedFeatureLifecycle calls AddClusterScopedFeatureLifecycleFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedFeatureLifecycle(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle) {
	if mock.AddClusterScopedFeatureLifecycleFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddClusterScopedFeatureLifecycleFunc: method is nil but SourceCodeCredentialInterface.AddClusterScopedFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v31.SourceCodeCredentialLifecycle
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureLifecycle.Lock()
	mock.calls.AddClusterScopedFeatureLifecycle = append(mock.calls.AddClusterScopedFeatureLifecycle, callInfo)
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureLifecycle.Unlock()
	mock.AddClusterScopedFeatureLifecycleFunc(ctx, enabled, name, clusterName, lifecycle)
}

// AddClusterScopedFeatureLifecycleCalls gets all the calls that were made to AddClusterScopedFeatureLifecycle.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddClusterScopedFeatureLifecycleCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedFeatureLifecycleCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Lifecycle   v31.SourceCodeCredentialLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v31.SourceCodeCredentialLifecycle
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureLifecycle.RLock()
	calls = mock.calls.AddClusterScopedFeatureLifecycle
	lockSourceCodeCredentialInterfaceMockAddClusterScopedFeatureLifecycle.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, syncMoqParam v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddClusterScopedHandlerFunc: method is nil but SourceCodeCredentialInterface.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Sync:        syncMoqParam,
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockSourceCodeCredentialInterfaceMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, syncMoqParam)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddClusterScopedHandlerCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Sync        v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockSourceCodeCredentialInterfaceMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddClusterScopedLifecycle calls AddClusterScopedLifecycleFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedLifecycle(ctx context.Context, name string, clusterName string, lifecycle v31.SourceCodeCredentialLifecycle) {
	if mock.AddClusterScopedLifecycleFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddClusterScopedLifecycleFunc: method is nil but SourceCodeCredentialInterface.AddClusterScopedLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v31.SourceCodeCredentialLifecycle
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedLifecycle.Lock()
	mock.calls.AddClusterScopedLifecycle = append(mock.calls.AddClusterScopedLifecycle, callInfo)
	lockSourceCodeCredentialInterfaceMockAddClusterScopedLifecycle.Unlock()
	mock.AddClusterScopedLifecycleFunc(ctx, name, clusterName, lifecycle)
}

// AddClusterScopedLifecycleCalls gets all the calls that were made to AddClusterScopedLifecycle.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddClusterScopedLifecycleCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddClusterScopedLifecycleCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Lifecycle   v31.SourceCodeCredentialLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v31.SourceCodeCredentialLifecycle
	}
	lockSourceCodeCredentialInterfaceMockAddClusterScopedLifecycle.RLock()
	calls = mock.calls.AddClusterScopedLifecycle
	lockSourceCodeCredentialInterfaceMockAddClusterScopedLifecycle.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddFeatureHandlerFunc: method is nil but SourceCodeCredentialInterface.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    syncMoqParam,
	}
	lockSourceCodeCredentialInterfaceMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockSourceCodeCredentialInterfaceMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, syncMoqParam)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddFeatureHandlerCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialInterfaceMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockSourceCodeCredentialInterfaceMockAddFeatureHandler.RUnlock()
	return calls
}

// AddFeatureLifecycle calls AddFeatureLifecycleFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddFeatureLifecycle(ctx context.Context, enabled func() bool, name string, lifecycle v31.SourceCodeCredentialLifecycle) {
	if mock.AddFeatureLifecycleFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddFeatureLifecycleFunc: method is nil but SourceCodeCredentialInterface.AddFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v31.SourceCodeCredentialLifecycle
	}{
		Ctx:       ctx,
		Enabled:   enabled,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockSourceCodeCredentialInterfaceMockAddFeatureLifecycle.Lock()
	mock.calls.AddFeatureLifecycle = append(mock.calls.AddFeatureLifecycle, callInfo)
	lockSourceCodeCredentialInterfaceMockAddFeatureLifecycle.Unlock()
	mock.AddFeatureLifecycleFunc(ctx, enabled, name, lifecycle)
}

// AddFeatureLifecycleCalls gets all the calls that were made to AddFeatureLifecycle.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddFeatureLifecycleCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddFeatureLifecycleCalls() []struct {
	Ctx       context.Context
	Enabled   func() bool
	Name      string
	Lifecycle v31.SourceCodeCredentialLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v31.SourceCodeCredentialLifecycle
	}
	lockSourceCodeCredentialInterfaceMockAddFeatureLifecycle.RLock()
	calls = mock.calls.AddFeatureLifecycle
	lockSourceCodeCredentialInterfaceMockAddFeatureLifecycle.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddHandler(ctx context.Context, name string, syncMoqParam v31.SourceCodeCredentialHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddHandlerFunc: method is nil but SourceCodeCredentialInterface.AddHandler was just called")
	}
	callInfo := struct {
		Ctx  context.Context
		Name string
		Sync v31.SourceCodeCredentialHandlerFunc
	}{
		Ctx:  ctx,
		Name: name,
		Sync: syncMoqParam,
	}
	lockSourceCodeCredentialInterfaceMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockSourceCodeCredentialInterfaceMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, syncMoqParam)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddHandlerCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddHandlerCalls() []struct {
	Ctx  context.Context
	Name string
	Sync v31.SourceCodeCredentialHandlerFunc
} {
	var calls []struct {
		Ctx  context.Context
		Name string
		Sync v31.SourceCodeCredentialHandlerFunc
	}
	lockSourceCodeCredentialInterfaceMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockSourceCodeCredentialInterfaceMockAddHandler.RUnlock()
	return calls
}

// AddLifecycle calls AddLifecycleFunc.
func (mock *SourceCodeCredentialInterfaceMock) AddLifecycle(ctx context.Context, name string, lifecycle v31.SourceCodeCredentialLifecycle) {
	if mock.AddLifecycleFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.AddLifecycleFunc: method is nil but SourceCodeCredentialInterface.AddLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Name      string
		Lifecycle v31.SourceCodeCredentialLifecycle
	}{
		Ctx:       ctx,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockSourceCodeCredentialInterfaceMockAddLifecycle.Lock()
	mock.calls.AddLifecycle = append(mock.calls.AddLifecycle, callInfo)
	lockSourceCodeCredentialInterfaceMockAddLifecycle.Unlock()
	mock.AddLifecycleFunc(ctx, name, lifecycle)
}

// AddLifecycleCalls gets all the calls that were made to AddLifecycle.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.AddLifecycleCalls())
func (mock *SourceCodeCredentialInterfaceMock) AddLifecycleCalls() []struct {
	Ctx       context.Context
	Name      string
	Lifecycle v31.SourceCodeCredentialLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Name      string
		Lifecycle v31.SourceCodeCredentialLifecycle
	}
	lockSourceCodeCredentialInterfaceMockAddLifecycle.RLock()
	calls = mock.calls.AddLifecycle
	lockSourceCodeCredentialInterfaceMockAddLifecycle.RUnlock()
	return calls
}

// Controller calls ControllerFunc.
func (mock *SourceCodeCredentialInterfaceMock) Controller() v31.SourceCodeCredentialController {
	if mock.ControllerFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.ControllerFunc: method is nil but SourceCodeCredentialInterface.Controller was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeCredentialInterfaceMockController.Lock()
	mock.calls.Controller = append(mock.calls.Controller, callInfo)
	lockSourceCodeCredentialInterfaceMockController.Unlock()
	return mock.ControllerFunc()
}

// ControllerCalls gets all the calls that were made to Controller.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.ControllerCalls())
func (mock *SourceCodeCredentialInterfaceMock) ControllerCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeCredentialInterfaceMockController.RLock()
	calls = mock.calls.Controller
	lockSourceCodeCredentialInterfaceMockController.RUnlock()
	return calls
}

// Create calls CreateFunc.
func (mock *SourceCodeCredentialInterfaceMock) Create(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error) {
	if mock.CreateFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.CreateFunc: method is nil but SourceCodeCredentialInterface.Create was just called")
	}
	callInfo := struct {
		In1 *v3.SourceCodeCredential
	}{
		In1: in1,
	}
	lockSourceCodeCredentialInterfaceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockSourceCodeCredentialInterfaceMockCreate.Unlock()
	return mock.CreateFunc(in1)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.CreateCalls())
func (mock *SourceCodeCredentialInterfaceMock) CreateCalls() []struct {
	In1 *v3.SourceCodeCredential
} {
	var calls []struct {
		In1 *v3.SourceCodeCredential
	}
	lockSourceCodeCredentialInterfaceMockCreate.RLock()
	calls = mock.calls.Create
	lockSourceCodeCredentialInterfaceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *SourceCodeCredentialInterfaceMock) Delete(name string, options *metav1.DeleteOptions) error {
	if mock.DeleteFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.DeleteFunc: method is nil but SourceCodeCredentialInterface.Delete was just called")
	}
	callInfo := struct {
		Name    string
		Options *metav1.DeleteOptions
	}{
		Name:    name,
		Options: options,
	}
	lockSourceCodeCredentialInterfaceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockSourceCodeCredentialInterfaceMockDelete.Unlock()
	return mock.DeleteFunc(name, options)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.DeleteCalls())
func (mock *SourceCodeCredentialInterfaceMock) DeleteCalls() []struct {
	Name    string
	Options *metav1.DeleteOptions
} {
	var calls []struct {
		Name    string
		Options *metav1.DeleteOptions
	}
	lockSourceCodeCredentialInterfaceMockDelete.RLock()
	calls = mock.calls.Delete
	lockSourceCodeCredentialInterfaceMockDelete.RUnlock()
	return calls
}

// DeleteCollection calls DeleteCollectionFunc.
func (mock *SourceCodeCredentialInterfaceMock) DeleteCollection(deleteOpts *metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	if mock.DeleteCollectionFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.DeleteCollectionFunc: method is nil but SourceCodeCredentialInterface.DeleteCollection was just called")
	}
	callInfo := struct {
		DeleteOpts *metav1.DeleteOptions
		ListOpts   metav1.ListOptions
	}{
		DeleteOpts: deleteOpts,
		ListOpts:   listOpts,
	}
	lockSourceCodeCredentialInterfaceMockDeleteCollection.Lock()
	mock.calls.DeleteCollection = append(mock.calls.DeleteCollection, callInfo)
	lockSourceCodeCredentialInterfaceMockDeleteCollection.Unlock()
	return mock.DeleteCollectionFunc(deleteOpts, listOpts)
}

// DeleteCollectionCalls gets all the calls that were made to DeleteCollection.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.DeleteCollectionCalls())
func (mock *SourceCodeCredentialInterfaceMock) DeleteCollectionCalls() []struct {
	DeleteOpts *metav1.DeleteOptions
	ListOpts   metav1.ListOptions
} {
	var calls []struct {
		DeleteOpts *metav1.DeleteOptions
		ListOpts   metav1.ListOptions
	}
	lockSourceCodeCredentialInterfaceMockDeleteCollection.RLock()
	calls = mock.calls.DeleteCollection
	lockSourceCodeCredentialInterfaceMockDeleteCollection.RUnlock()
	return calls
}

// DeleteNamespaced calls DeleteNamespacedFunc.
func (mock *SourceCodeCredentialInterfaceMock) DeleteNamespaced(namespace string, name string, options *metav1.DeleteOptions) error {
	if mock.DeleteNamespacedFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.DeleteNamespacedFunc: method is nil but SourceCodeCredentialInterface.DeleteNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Options   *metav1.DeleteOptions
	}{
		Namespace: namespace,
		Name:      name,
		Options:   options,
	}
	lockSourceCodeCredentialInterfaceMockDeleteNamespaced.Lock()
	mock.calls.DeleteNamespaced = append(mock.calls.DeleteNamespaced, callInfo)
	lockSourceCodeCredentialInterfaceMockDeleteNamespaced.Unlock()
	return mock.DeleteNamespacedFunc(namespace, name, options)
}

// DeleteNamespacedCalls gets all the calls that were made to DeleteNamespaced.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.DeleteNamespacedCalls())
func (mock *SourceCodeCredentialInterfaceMock) DeleteNamespacedCalls() []struct {
	Namespace string
	Name      string
	Options   *metav1.DeleteOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Options   *metav1.DeleteOptions
	}
	lockSourceCodeCredentialInterfaceMockDeleteNamespaced.RLock()
	calls = mock.calls.DeleteNamespaced
	lockSourceCodeCredentialInterfaceMockDeleteNamespaced.RUnlock()
	return calls
}

// Get calls GetFunc.
func (mock *SourceCodeCredentialInterfaceMock) Get(name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error) {
	if mock.GetFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.GetFunc: method is nil but SourceCodeCredentialInterface.Get was just called")
	}
	callInfo := struct {
		Name string
		Opts metav1.GetOptions
	}{
		Name: name,
		Opts: opts,
	}
	lockSourceCodeCredentialInterfaceMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockSourceCodeCredentialInterfaceMockGet.Unlock()
	return mock.GetFunc(name, opts)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.GetCalls())
func (mock *SourceCodeCredentialInterfaceMock) GetCalls() []struct {
	Name string
	Opts metav1.GetOptions
} {
	var calls []struct {
		Name string
		Opts metav1.GetOptions
	}
	lockSourceCodeCredentialInterfaceMockGet.RLock()
	calls = mock.calls.Get
	lockSourceCodeCredentialInterfaceMockGet.RUnlock()
	return calls
}

// GetNamespaced calls GetNamespacedFunc.
func (mock *SourceCodeCredentialInterfaceMock) GetNamespaced(namespace string, name string, opts metav1.GetOptions) (*v3.SourceCodeCredential, error) {
	if mock.GetNamespacedFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.GetNamespacedFunc: method is nil but SourceCodeCredentialInterface.GetNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Opts      metav1.GetOptions
	}{
		Namespace: namespace,
		Name:      name,
		Opts:      opts,
	}
	lockSourceCodeCredentialInterfaceMockGetNamespaced.Lock()
	mock.calls.GetNamespaced = append(mock.calls.GetNamespaced, callInfo)
	lockSourceCodeCredentialInterfaceMockGetNamespaced.Unlock()
	return mock.GetNamespacedFunc(namespace, name, opts)
}

// GetNamespacedCalls gets all the calls that were made to GetNamespaced.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.GetNamespacedCalls())
func (mock *SourceCodeCredentialInterfaceMock) GetNamespacedCalls() []struct {
	Namespace string
	Name      string
	Opts      metav1.GetOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Opts      metav1.GetOptions
	}
	lockSourceCodeCredentialInterfaceMockGetNamespaced.RLock()
	calls = mock.calls.GetNamespaced
	lockSourceCodeCredentialInterfaceMockGetNamespaced.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *SourceCodeCredentialInterfaceMock) List(opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error) {
	if mock.ListFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.ListFunc: method is nil but SourceCodeCredentialInterface.List was just called")
	}
	callInfo := struct {
		Opts metav1.ListOptions
	}{
		Opts: opts,
	}
	lockSourceCodeCredentialInterfaceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockSourceCodeCredentialInterfaceMockList.Unlock()
	return mock.ListFunc(opts)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.ListCalls())
func (mock *SourceCodeCredentialInterfaceMock) ListCalls() []struct {
	Opts metav1.ListOptions
} {
	var calls []struct {
		Opts metav1.ListOptions
	}
	lockSourceCodeCredentialInterfaceMockList.RLock()
	calls = mock.calls.List
	lockSourceCodeCredentialInterfaceMockList.RUnlock()
	return calls
}

// ListNamespaced calls ListNamespacedFunc.
func (mock *SourceCodeCredentialInterfaceMock) ListNamespaced(namespace string, opts metav1.ListOptions) (*v3.SourceCodeCredentialList, error) {
	if mock.ListNamespacedFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.ListNamespacedFunc: method is nil but SourceCodeCredentialInterface.ListNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Opts      metav1.ListOptions
	}{
		Namespace: namespace,
		Opts:      opts,
	}
	lockSourceCodeCredentialInterfaceMockListNamespaced.Lock()
	mock.calls.ListNamespaced = append(mock.calls.ListNamespaced, callInfo)
	lockSourceCodeCredentialInterfaceMockListNamespaced.Unlock()
	return mock.ListNamespacedFunc(namespace, opts)
}

// ListNamespacedCalls gets all the calls that were made to ListNamespaced.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.ListNamespacedCalls())
func (mock *SourceCodeCredentialInterfaceMock) ListNamespacedCalls() []struct {
	Namespace string
	Opts      metav1.ListOptions
} {
	var calls []struct {
		Namespace string
		Opts      metav1.ListOptions
	}
	lockSourceCodeCredentialInterfaceMockListNamespaced.RLock()
	calls = mock.calls.ListNamespaced
	lockSourceCodeCredentialInterfaceMockListNamespaced.RUnlock()
	return calls
}

// ObjectClient calls ObjectClientFunc.
func (mock *SourceCodeCredentialInterfaceMock) ObjectClient() *objectclient.ObjectClient {
	if mock.ObjectClientFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.ObjectClientFunc: method is nil but SourceCodeCredentialInterface.ObjectClient was just called")
	}
	callInfo := struct {
	}{}
	lockSourceCodeCredentialInterfaceMockObjectClient.Lock()
	mock.calls.ObjectClient = append(mock.calls.ObjectClient, callInfo)
	lockSourceCodeCredentialInterfaceMockObjectClient.Unlock()
	return mock.ObjectClientFunc()
}

// ObjectClientCalls gets all the calls that were made to ObjectClient.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.ObjectClientCalls())
func (mock *SourceCodeCredentialInterfaceMock) ObjectClientCalls() []struct {
} {
	var calls []struct {
	}
	lockSourceCodeCredentialInterfaceMockObjectClient.RLock()
	calls = mock.calls.ObjectClient
	lockSourceCodeCredentialInterfaceMockObjectClient.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *SourceCodeCredentialInterfaceMock) Update(in1 *v3.SourceCodeCredential) (*v3.SourceCodeCredential, error) {
	if mock.UpdateFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.UpdateFunc: method is nil but SourceCodeCredentialInterface.Update was just called")
	}
	callInfo := struct {
		In1 *v3.SourceCodeCredential
	}{
		In1: in1,
	}
	lockSourceCodeCredentialInterfaceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockSourceCodeCredentialInterfaceMockUpdate.Unlock()
	return mock.UpdateFunc(in1)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.UpdateCalls())
func (mock *SourceCodeCredentialInterfaceMock) UpdateCalls() []struct {
	In1 *v3.SourceCodeCredential
} {
	var calls []struct {
		In1 *v3.SourceCodeCredential
	}
	lockSourceCodeCredentialInterfaceMockUpdate.RLock()
	calls = mock.calls.Update
	lockSourceCodeCredentialInterfaceMockUpdate.RUnlock()
	return calls
}

// Watch calls WatchFunc.
func (mock *SourceCodeCredentialInterfaceMock) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	if mock.WatchFunc == nil {
		panic("SourceCodeCredentialInterfaceMock.WatchFunc: method is nil but SourceCodeCredentialInterface.Watch was just called")
	}
	callInfo := struct {
		Opts metav1.ListOptions
	}{
		Opts: opts,
	}
	lockSourceCodeCredentialInterfaceMockWatch.Lock()
	mock.calls.Watch = append(mock.calls.Watch, callInfo)
	lockSourceCodeCredentialInterfaceMockWatch.Unlock()
	return mock.WatchFunc(opts)
}

// WatchCalls gets all the calls that were made to Watch.
// Check the length with:
//     len(mockedSourceCodeCredentialInterface.WatchCalls())
func (mock *SourceCodeCredentialInterfaceMock) WatchCalls() []struct {
	Opts metav1.ListOptions
} {
	var calls []struct {
		Opts metav1.ListOptions
	}
	lockSourceCodeCredentialInterfaceMockWatch.RLock()
	calls = mock.calls.Watch
	lockSourceCodeCredentialInterfaceMockWatch.RUnlock()
	return calls
}

var (
	lockSourceCodeCredentialsGetterMockSourceCodeCredentials sync.RWMutex
)

// Ensure, that SourceCodeCredentialsGetterMock does implement v31.SourceCodeCredentialsGetter.
// If this is not the case, regenerate this file with moq.
var _ v31.SourceCodeCredentialsGetter = &SourceCodeCredentialsGetterMock{}

// SourceCodeCredentialsGetterMock is a mock implementation of v31.SourceCodeCredentialsGetter.
//
//     func TestSomethingThatUsesSourceCodeCredentialsGetter(t *testing.T) {
//
//         // make and configure a mocked v31.SourceCodeCredentialsGetter
//         mockedSourceCodeCredentialsGetter := &SourceCodeCredentialsGetterMock{
//             SourceCodeCredentialsFunc: func(namespace string) v31.SourceCodeCredentialInterface {
// 	               panic("mock out the SourceCodeCredentials method")
//             },
//         }
//
//         // use mockedSourceCodeCredentialsGetter in code that requires v31.SourceCodeCredentialsGetter
//         // and then make assertions.
//
//     }
type SourceCodeCredentialsGetterMock struct {
	// SourceCodeCredentialsFunc mocks the SourceCodeCredentials method.
	SourceCodeCredentialsFunc func(namespace string) v31.SourceCodeCredentialInterface

	// calls tracks calls to the methods.
	calls struct {
		// SourceCodeCredentials holds details about calls to the SourceCodeCredentials method.
		SourceCodeCredentials []struct {
			// Namespace is the namespace argument value.
			Namespace string
		}
	}
}

// SourceCodeCredentials calls SourceCodeCredentialsFunc.
func (mock *SourceCodeCredentialsGetterMock) SourceCodeCredentials(namespace string) v31.SourceCodeCredentialInterface {
	if mock.SourceCodeCredentialsFunc == nil {
		panic("SourceCodeCredentialsGetterMock.SourceCodeCredentialsFunc: method is nil but SourceCodeCredentialsGetter.SourceCodeCredentials was just called")
	}
	callInfo := struct {
		Namespace string
	}{
		Namespace: namespace,
	}
	lockSourceCodeCredentialsGetterMockSourceCodeCredentials.Lock()
	mock.calls.SourceCodeCredentials = append(mock.calls.SourceCodeCredentials, callInfo)
	lockSourceCodeCredentialsGetterMockSourceCodeCredentials.Unlock()
	return mock.SourceCodeCredentialsFunc(namespace)
}

// SourceCodeCredentialsCalls gets all the calls that were made to SourceCodeCredentials.
// Check the length with:
//     len(mockedSourceCodeCredentialsGetter.SourceCodeCredentialsCalls())
func (mock *SourceCodeCredentialsGetterMock) SourceCodeCredentialsCalls() []struct {
	Namespace string
} {
	var calls []struct {
		Namespace string
	}
	lockSourceCodeCredentialsGetterMockSourceCodeCredentials.RLock()
	calls = mock.calls.SourceCodeCredentials
	lockSourceCodeCredentialsGetterMockSourceCodeCredentials.RUnlock()
	return calls
}
